import os, glob, datetime
import time
import sys
import numpy as np
from scipy import interpolate

#kalibrerings verdier
actual_temp=np.array([0.0,20.0,40.0,50.0,60.0,70.0,80.0,90.0,100.0])
malt_differance=np.array([0.44,0.48,0.48,0.41,0.34,0.22,0.07,-0.14,-0.36])

#interpolert avviks funksjon
temp_interpolated=interpolate.interp1d(actual_temp,malt_differance,kind='cubic')



start= time.time()
log_period = 120# seconds måletid

logging_folder = glob.glob('/home/pi/templogger*')[0]
dt = datetime.datetime.now()
file_name = "test1{:%Y_%m_%d}.csv".format(dt) #sett filnavn
logging_file = logging_folder + '/' + file_name

os.system('modprobe w1-gpio')
os.system('modprobe w1-therm')
 
base_dir = '/sys/bus/w1/devices/'
device_folder = glob.glob(base_dir + '28*')[0]
device_file = device_folder + '/w1_slave'
 
def read_temp_raw():
    f = open(device_file, 'r')
    lines = f.readlines()
    f.close()
    return lines
 
def read_temp():
    lines = read_temp_raw()
    while lines[0].strip()[-3:] != 'YES':
        time.sleep(0.2)
        lines = read_temp_raw()
    equals_pos = lines[1].find('t=')
    if equals_pos != -1:
        temp_string = lines[1][equals_pos+2:]
        temp_c = float (temp_string) / 1000.0
        temp_c_cal =round(temp_c+temp_interpolated(temp_c),2)
        #temp_f = temp_c * 9.0 / 5.0 + 32.0
        return temp_c_cal

def log_temp():
    temp_c_cal = read_temp()
    dt = datetime.datetime.now()
    f = open(logging_file, 'a')
    f.write('\n"{:%H:%M:%S}",'.format(dt))
    f.write(str(temp_c_cal))
    f.close()

print("temp C=",read_temp())
print("Logging to: " + logging_file)

while time.time()<start+log_period:
    log_temp()
    print("temp C=", read_temp())
    

sys.exit()
